//+------------------------------------------------------------------+
//|                                            Parabolic_for_RSI.mq4 |
//|                      Copyright  2008, MetaQuotes Software Corp. |
//|                      Copyright  2008,  .. aka lukas1.  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, MetaQuotes + lukas1"
#property link      ""

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 Red
#property indicator_color2 Lime
#property indicator_level1 50
#property indicator_level2 60
#property indicator_level3 40
//---- input parameters
extern int RSIPeriod=26;
extern double Step=0.02;
//---- buffers
double SarBuffer[];

double RSIBuffer[];
double PosBuffer[];
double NegBuffer[];
//----
double var_Step;
double var_Maximum;
int    save_lastreverse;
bool   save_dirlong;
double save_start;
double save_last_high;
double save_last_low;
double save_ep;
double save_sar;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   IndicatorDigits(Digits+1);
   IndicatorBuffers(4);
//----
   int  var_Step=Step*10000;
//----
   string Plusvar_Step="";
   if (var_Step<10    ) Plusvar_Step="0.000";
   else
   if (var_Step<100   ) Plusvar_Step="0.00";
   else
   if (var_Step<1000  ) Plusvar_Step="0.0";
   else
   if (var_Step<10000 ) Plusvar_Step="0.";
   else
   Plusvar_Step="";
//----
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,RSIBuffer);
   SetIndexLabel(0," RSI ("+RSIPeriod+") ");
   SetIndexDrawBegin(0,RSIPeriod);
//----
   SetIndexBuffer(2,PosBuffer);
   SetIndexBuffer(3,NegBuffer);
//----
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexArrow(1,159);
   SetIndexBuffer(1,SarBuffer);
   SetIndexLabel(1,"Step= "+Plusvar_Step+var_Step);
//---- name for DataWindow and indicator subwindow label
   string short_name="RSI ("+RSIPeriod+"), Step ("+Plusvar_Step+var_Step+") ";
   IndicatorShortName(short_name);

//----   

   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void SaveLastReverse(int last,int dir,double start,double low,double high,double ep,double sar)
  {
   save_lastreverse=last;
   save_dirlong=dir;
   save_start=start;
   save_last_low=low;
   save_last_high=high;
   save_ep=ep;
   save_sar=sar;
  }
//+------------------------------------------------------------------+
//| RSI plus Parabolic Sell And Reverse system                                |
//+------------------------------------------------------------------+
int start()
  {
   static bool first=true;
   bool   dirlong;
   double start,last_high,last_low;
   double ep,sar,price_low,price_high,price;
   int    i,counted_bars=IndicatorCounted();
//----
   if(Bars<3) return(0);
//----

   double rel,negative,positive,sma;
//----
   if(Bars<=RSIPeriod) return(0);
//---- initial zero
   if(counted_bars<1)
      for(i=1;i<=RSIPeriod;i++) RSIBuffer[Bars-i]=0.0;
//----
   i=Bars-RSIPeriod-1;
   if(counted_bars>=RSIPeriod) i=Bars-counted_bars-1;
   while(i>=0)
     {
      double sumn=0.0,sump=0.0;
      if(i==Bars-RSIPeriod-1)
        {
         int k=Bars-2;
         //---- initial accumulation
         while(k>=i)
           {
            rel=Close[k]-Close[k+1];
            if(rel>0) sump+=rel;
            else      sumn-=rel;
            k--;
           }
         positive=sump/RSIPeriod;
         negative=sumn/RSIPeriod;
        }
      else
        {
         //---- smoothed moving average
         rel=Close[i]-Close[i+1];
         if(rel>0) sump=rel;
         else      sumn=-rel;
         positive=(PosBuffer[i+1]*(RSIPeriod-1)+sump)/RSIPeriod;
         negative=(NegBuffer[i+1]*(RSIPeriod-1)+sumn)/RSIPeriod;
        }
      PosBuffer[i]=positive;
      NegBuffer[i]=negative;
      if(negative==0.0) RSIBuffer[i]=0.0; 
      else RSIBuffer[i]=100.0-100.0/(1+positive/negative);
     
      i--;
     }
//---- finish calculation RSI

//---- initial settings
   i=Bars-2;
      first=false;
      dirlong=true;
      start=Step;
      last_high=-10000000.0;
      last_low=10000000.0;
   while(i>=0)
     {
      price_low=RSIBuffer[i];
      price_high=RSIBuffer[i];
      price=SarBuffer[i+1];//   SarBuffer  
      //sar         
      //(    SarBuffer  )
      sar=price+start*(ep-price);
//----
      if(dirlong)
        {
         if(sar>price_low)
           {
            SaveLastReverse(i,true,start,price_low,last_high,ep,sar);
            start=Step; 
            dirlong=false; 
            ep=price_low;
            last_low=price_low;
            SarBuffer[i]=last_high;
            i--;
            continue;
           }
         if(ep<price_high) { last_high=price_high; ep=price_high; }
        }
//----
      else
        {
         if(sar<price_high)
           {
            SaveLastReverse(i,false,start,last_low,price_high,ep,sar);
            start=Step; 
            dirlong=true; 
            ep=price_high;
            last_high=price_high;
            SarBuffer[i]=last_low;
            i--;
            continue;
           }
         if(ep>price_low) { last_low=price_low; ep=price_low; }
        }
      SarBuffer[i]=sar;
      i--;
     }
//----
//----
   return(0);
  }
//+------------------------------------------------------------------+